#include <iostream>
#include <string>

using namespace std;

int check(string a, string b)
{
    int d1 = a.length(), d2 = a.length(); int counter = 0;

    if (d2 >= d1){
        for (int i = 0; i < d1; i++){
            d2--;
            if (a[i] == b[d2]){
                counter++;
            }
        }
    }
    else {
        for (int i = 0; i < d2; i++){
            d1--;
            if (b[i] == a[d1]){
                counter++;
            }
        }
    }
    return counter;
}

string del(string a, int loc)
{
    string ret;
    for (int i = loc; i < a.length(); i++){
        ret = ret + a[i];
    }
    return ret;
}
int  rezultat = 0;
void rez(string str)
{
    int loc = 0;
    int mx = 0;
    if (str.length() >= 2){


    //cout << "works, the rez is: " << rez << endl;
    for (int i = 2; i < str.length() - 1; i++){
        string a = str.substr(0, i);
        string b = str.substr(i, str.length() - i);
        //cout << a << "(prvi deo), " << b << "(drugi deo), " << i << "(i)" << endl;
        if (check(a, b) > mx){
            mx = check(a, b);
            loc = i;
        }
    }
    if (mx != 0){


    rezultat = mx + rezultat;
    //cout << mx << "(max), " << loc << "(breakpoint)" << endl;

    string the_rest = del(str, loc);


    rez(the_rest);
    }
    }
}

int main()
{
    string a;// = "";
    cin >> a;

    rez(a);
    cout << rezultat;
}